import casadi.*

a = [...];
m = ...;

b = [...];
n = ...;

C = [...];

X = MX.sym('X', m, n);

f = 0;

for i = 1:m
    
    for j = 1:n
        
        f = f + C(...,...) * X(...,...); 
        
    end 
    
end


g = {};
g_min = [];
g_max = [];


for i = 1:m

    e = 0;

    for j = 1:n

        e = e + X(...,...);
    end
           
    g = {g{:} e};
    g_min = [g_min; a(i)];
    g_max = [g_max; a(i)];

end

for j = 1:n

    e = 0;

    for i = 1:m

        e = e + X(...,...);

    end
        
    g = {g{:} e};
    g_min = [g_min; b(j)];
    g_max = [g_max; b(j)];

end


g = vertcat(g{:});
X = vec(X);

lp = struct('x', X, 'f', f, 'g', g);

solver = nlpsol('solver', 'ipopt', lp);

X_init = zeros(size(X));
X_min = zeros(size(X));
X_max = Inf(size(X));

solution = solver('x0', X_init, 'lbx', X_min, 'ubx', X_max, ...
    'lbg', g_min, 'ubg', g_max);

K_opt = solution.f;
X_opt = reshape(solution.x, 3, 5);

fprintf('\nTransportation cost:\n\n');
disp(full(K_opt));

fprintf('\nTransportation matrix:\n\n');
disp(full(X_opt));
